Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 2007)
@@ -43,5 +43,5 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_iomput = .FALSE.       !: iom_put flag
 #endif
-   PUBLIC iom_init, iom_open, iom_close, iom_setkt, iom_varid, iom_get, iom_gettime, iom_rstput, iom_put
+   PUBLIC iom_init, iom_swap, iom_open, iom_close, iom_setkt, iom_varid, iom_get, iom_gettime, iom_rstput, iom_put
 
    PRIVATE iom_rp0d, iom_rp1d, iom_rp2d, iom_rp3d
@@ -86,5 +86,6 @@
       !!----------------------------------------------------------------------
       ! read the xml file
-      CALL event__parse_xml_file( 'iodef.xml' )   ! <- to get from the nameliste (namrun)...
+      IF( Agrif_Root() ) CALL event__parse_xml_file( 'iodef.xml' )   ! <- to get from the nameliste (namrun)...
+      CALL iom_swap
 
       ! calendar parameters
@@ -119,4 +120,22 @@
 
    END SUBROUTINE iom_init
+
+
+   SUBROUTINE iom_swap
+      !!---------------------------------------------------------------------
+      !!                   ***  SUBROUTINE  iom_swap  ***
+      !!
+      !! ** Purpose :  swap context between different agrif grid for xmlio_server
+      !!---------------------------------------------------------------------
+#if defined key_iomput
+
+     IF( TRIM(Agrif_CFixed()) == '0' ) THEN
+        CALL event__swap_context("nemo")
+     ELSE
+        CALL event__swap_context(TRIM(Agrif_CFixed())//"_nemo")
+     ENDIF
+
+#endif
+   END SUBROUTINE iom_swap
 
 
@@ -164,10 +183,4 @@
       ! if iom_open is called for the first time: initialize iom_file(:)%nfid to 0
       ! (could be done when defining iom_file in f95 but not in f90)
-#if ! defined key_agrif
-      IF( iom_open_init == 0 ) THEN
-         iom_file(:)%nfid = 0
-         iom_open_init = 1
-      ENDIF
-#else
       IF( Agrif_Root() ) THEN
          IF( iom_open_init == 0 ) THEN
@@ -176,5 +189,4 @@
          ENDIF
       ENDIF
-#endif
       ! do we read or write the file?
       IF( PRESENT(ldwrt) ) THEN   ;   llwrt = ldwrt
@@ -199,5 +211,4 @@
       ! =============
       clname   = trim(cdname)
-#if defined key_agrif
       IF ( .NOT. Agrif_Root() .AND. .NOT. lliof ) THEN
          iln    = INDEX(clname,'/') 
@@ -206,5 +217,4 @@
          clname=TRIM(cltmpn)//TRIM(Agrif_CFixed())//'_'//TRIM(clname)
       ENDIF
-#endif    
       ! which suffix should we use?
       SELECT CASE (iolib)
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_oce.F90	(revision 2007)
@@ -27,5 +27,4 @@
    !
    !                                  !!* Namelist namobc: open boundary condition *
-   INTEGER           ::   nn_nbobc    = 2        !: number of open boundaries ( 1=< nbobc =< 4 ) 
    INTEGER           ::   nn_obcdta   = 0        !:  = 0 use the initial state as obc data
    !                                             !   = 1 read obc data in obcxxx.dta files
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par.F90	(revision 2007)
@@ -25,5 +25,9 @@
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_obc = .TRUE.   !: Ocean Boundary Condition flag
+#if ! defined key_agrif
+   LOGICAL, PUBLIC, PARAMETER ::   lk_obc = .TRUE.     !: Ocean Boundary Condition flag
+#else
+   LOGICAL, PUBLIC            ::   lk_obc = .TRUE.     !: Ocean Boundary Condition flag
+#endif
 
 # if defined key_eel_r5
@@ -43,10 +47,10 @@
    !! open boundary parameter
    !!---------------------------------------------------------------------
-   INTEGER, PARAMETER ::     &  !: time dimension of the BCS fields on input
+   INTEGER ::     &  !: time dimension of the BCS fields on input
       jptobc  =	      2 
    !! * EAST open boundary
-   LOGICAL, PARAMETER ::     &  !:
+   LOGICAL ::     &  !:
       lp_obc_east = .FALSE.     !: to active or not the East open boundary
-   INTEGER, PARAMETER ::     &  !:
+   INTEGER ::     & 
       jpieob  = jpiglo-2,    &  !: i-localization of the East open boundary (must be ocean U-point)
       jpjed   =        2,    &  !: j-starting indice of the East open boundary (must be land T-point)
@@ -56,7 +60,7 @@
 
    !! * WEST open boundary
-   LOGICAL, PARAMETER ::     &  !:
+   LOGICAL ::     &  !:
       lp_obc_west = .FALSE.     !: to active or not the West open boundary
-   INTEGER, PARAMETER ::     &  !:
+   INTEGER ::     &  !:
       jpiwob  =	       2,    &  !: i-localization of the West open boundary (must be ocean U-point)
       jpjwd   =	       2,    &  !: j-starting indice of the West open boundary (must be land T-point)
@@ -66,7 +70,7 @@
 
    !! * NORTH open boundary
-   LOGICAL, PARAMETER ::     &  !:
+   LOGICAL ::     &  !:
       lp_obc_north = .FALSE.    !: to active or not the North open boundary
-   INTEGER, PARAMETER ::     &  !:
+   INTEGER ::     &  !:
       jpjnob  = jpjglo-2,    &  !: j-localization of the North open boundary (must be ocean V-point)
       jpind   =        2,    &  !: i-starting indice of the North open boundary (must be land T-point)
@@ -76,7 +80,7 @@
 
    !! * SOUTH open boundary
-   LOGICAL, PARAMETER ::     &  !:
+   LOGICAL ::     &  !:
       lp_obc_south = .FALSE.    !: to active or not the South open boundary
-   INTEGER, PARAMETER ::     &  !:
+   INTEGER ::     &  !:
       jpjsob  =        2,    &  !: j-localization of the South open boundary (must be ocean V-point)
       jpisd   =        2,    &  !: i-starting indice of the South open boundary (must be land T-point)
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_EEL_R5.h90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_EEL_R5.h90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_EEL_R5.h90	(revision 2007)
@@ -15,5 +15,10 @@
    LOGICAL, PARAMETER ::     &  !:
       lp_obc_east = .TRUE.      !: to active or not the East open boundary
-   INTEGER, PARAMETER ::     &  !:
+
+     INTEGER   &
+#if !defined key_agrif
+     , PARAMETER   &
+#endif
+    ::     &
       jpieob  = jpiglo-2,    &  !: i-localization of the East open boundary (must be ocean U-point)
       jpjed   =        2,    &  !: j-starting indice of the East open boundary (must be land T-point)
@@ -25,5 +30,10 @@
    LOGICAL, PARAMETER ::     &  !:
       lp_obc_west = .TRUE.      !: to active or not the West open boundary
-   INTEGER, PARAMETER ::     &
+
+     INTEGER   &
+#if !defined key_agrif
+     , PARAMETER   &
+#endif
+    ::     &
       jpiwob  =	       2,    &  !: i-localization of the West open boundary (must be ocean U-point)
       jpjwd   =	       2,    &  !: j-starting indice of the West open boundary (must be land T-point)
@@ -35,5 +45,10 @@
    LOGICAL, PARAMETER ::     &  !:
       lp_obc_north = .FALSE.    !: to active or not the North open boundary
-   INTEGER, PARAMETER ::     &  !:
+
+     INTEGER   &
+#if !defined key_agrif
+     , PARAMETER   &
+#endif
+    ::     &
       jpjnob  = jpjglo-2,    &  !: j-localization of the North open boundary (must be ocean V-point)
       jpind   =        2,    &  !: i-starting indice of the North open boundary (must be land T-point)
@@ -45,5 +60,10 @@
    LOGICAL, PARAMETER ::     &  !:
       lp_obc_south = .FALSE.    !: to active or not the South open boundary
-   INTEGER, PARAMETER ::     &  !:
+
+     INTEGER   &
+#if !defined key_agrif
+     , PARAMETER   &
+#endif
+    ::     &
       jpjsob  =        2,    &  !: j-localization of the South open boundary (must be ocean V-point)
       jpisd   =        2,    &  !: i-starting indice of the South open boundary (must be land T-point)
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_POMME_R025.h90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_POMME_R025.h90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obc_par_POMME_R025.h90	(revision 2007)
@@ -4,21 +4,23 @@
    !! open boundary parameter : POMME configuration
    !!---------------------------------------------------------------------
-     INTEGER, PARAMETER ::     &  !: time dimension of the BCS fields on input
-      jptobc  =	      14
+   INTEGER, PARAMETER ::  jptobc  =	      14   
+   !: time dimension of the BCS fields on input
 
    !! * EAST open boundary
    LOGICAL, PARAMETER ::     &  !:
       lp_obc_east = .TRUE.      !:
-   INTEGER, PARAMETER ::     &  !:
 
+     INTEGER   &
+#if !defined key_agrif
+     , PARAMETER   & 
+#endif
+    ::     & 
       ! * default values *
       !jpieob = jpiglo-2,    &  !: i-localization of the East open boundary (must be ocean U-point)
       !jpjed  =        2,    &  !: j-starting indice of the East open boundary (must be land T-point)
       !jpjef  = jpjglo-1,    &  !: j-ending   indice of the East open boundary (must be land T-point)
-
       jpieob = jpiglo-2,    &  !: i-localization of the East open boundary (must be ocean U-point)
       jpjed  =        1,    &  !: j-starting indice of the East open boundary (must be land T-point)
       jpjef  =   jpjglo,    &  !: j-ending   indice of the East open boundary (must be land T-point)
-
       jpjedp1 =  jpjed+1,    &  !: first ocean point         "                 "
       jpjefm1 =  jpjef-1        !: last  ocean point         "                 "
@@ -27,15 +29,17 @@
    LOGICAL, PARAMETER ::     &  !:
       lp_obc_west = .TRUE.     !: to active or not the West open boundary
-   INTEGER, PARAMETER ::     &  !:
 
+     INTEGER   &
+#if !defined key_agrif
+     , PARAMETER   & 
+#endif
+    ::     & 
       ! * default values *
       !jpiwob  =        2,   &  !: i-localization of the West open boundary (must be ocean U-point)
       !jpjwd   =        2,   &  !: j-starting indice of the West open boundary (must be land T-point)
       !jpjwf   = jpjglo-1,   &  !: j-ending   indice of the West open boundary (must be land T-point)
-
       jpiwob  =        2,   &  !: i-localization of the West open boundary (must be ocean U-point)
       jpjwd   =        1,   &  !: j-starting indice of the West open boundary (must be land T-point)
       jpjwf   =   jpjglo,   &  !: j-ending   indice of the West open boundary (must be land T-point)
-
       jpjwdp1 =  jpjwd+1,    &  !: first ocean point         "                 "
       jpjwfm1 =  jpjwf-1        !: last  ocean point         "                 "
@@ -44,15 +48,17 @@
    LOGICAL, PARAMETER ::     &  !:
       lp_obc_north = .TRUE.     !:
-   INTEGER, PARAMETER ::     &  !:
 
+     INTEGER   &
+#if !defined key_agrif
+     , PARAMETER   & 
+#endif
+    ::     & 
       ! * default values *
       !jpjnob = jpjglo-2,    &  !: j-localization of the North open boundary (must be ocean V-point)
       !jpind  =        2,    &  !: i-starting indice of the North open boundary (must be land T-point)
       !jpinf  = jpiglo-1,    &  !: i-ending   indice of the North open boundary (must be land T-point)
-
       jpjnob = jpjglo-2,    &  !: j-localization of the North open boundary (must be ocean V-point)
       jpind  =        1,    &  !: i-starting indice of the North open boundary (must be land T-point)
       jpinf  =   jpiglo,    &  !: i-ending   indice of the North open boundary (must be land T-point)
-
       jpindp1 =  jpind+1,    &  !: first ocean point         "                 "
       jpinfm1 =  jpinf-1        !: last  ocean point         "                 "
@@ -61,15 +67,17 @@
    LOGICAL, PARAMETER ::     &  !:
       lp_obc_south = .TRUE.     !: INDICE to active or not the South open boundary
-   INTEGER, PARAMETER ::     &  !:
 
+     INTEGER   &
+#if !defined key_agrif
+     , PARAMETER   & 
+#endif
+    ::     & 
       ! * default values *
       !jpjsob =        2,    &  !: j-localization of the South open boundary (must be ocean V-point)
       !jpisd  =        2,    &  !: i-starting indice of the South open boundary (must be land T-point)
       !jpisf  = jpiglo-1,    &  !: i-ending   indice of the South open boundary (must be land T-point)
-
       jpjsob =        2,    &  !: j-localization of the South open boundary (must be ocean V-point)
       jpisd  =        1,    &  !: i-starting indice of the South open boundary (must be land T-point)
       jpisf  =   jpiglo,    &  !: i-ending   indice of the South open boundary (must be land T-point)
-
       jpisdp1 =  jpisd+1,    &  !: first ocean point         "                 "
       jpisfm1 =  jpisf-1        !: last  ocean point         "                 "
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 2007)
@@ -469,5 +469,9 @@
        ENDIF
     ELSE
+#if defined key_agrif
+       IF ( ASSOCIATED(ztcobc) ) DEALLOCATE ( ztcobc )
+#else
        IF ( ALLOCATED(ztcobc) ) DEALLOCATE ( ztcobc )
+#endif
        ALLOCATE (ztcobc(itobc))
        DO ji=1,1   ! use a dummy loop to read ztcobc only once
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcfla.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcfla.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcfla.F90	(revision 2007)
@@ -82,10 +82,8 @@
 
       DO ji = nie0, nie1
-         DO jk = 1, jpkm1
-            DO jj = 1, jpj
-               ua_e(ji,jj) = (  ubtfoe(jj) + sqrt( grav*hu(ji,jj) )           &
-                  &            * ( ( sshn_e(ji,jj) + sshn_e(ji+1,jj) ) * 0.5  &
-                  &            - sshfoe(jj) )  ) * uemsk(jj,jk)
-            END DO
+         DO jj = 1, jpj
+            ua_e(ji,jj) = (  ubtfoe(jj) * hur(ji,jj) + sqrt( grav*hur(ji,jj) )   &
+               &            * ( ( sshn_e(ji,jj) + sshn_e(ji+1,jj) ) * 0.5        &
+               &            - sshfoe(jj) )  ) * uemsk(jj,jk)
          END DO
       END DO
@@ -97,5 +95,5 @@
             ssha_e(ji,jj) = ssha_e(ji,jj) * ( 1. - temsk(jj,1) ) &
                &            + temsk(jj,1) * sshfoe(jj)
-            va_e(ji,jj) = vbtfoe(jj) * uemsk(jj,jk)
+            va_e(ji,jj) = vbtfoe(jj) * hvr(ji,jj) * uemsk(jj,jk)
          END DO
       END DO
@@ -120,11 +118,9 @@
 
       DO ji = niw0, niw1
-         DO jk = 1, jpkm1
-            DO jj = 1, jpj
-               ua_e(ji,jj) = ( ubtfow(jj) - sqrt( grav * hu(ji,jj) )          &
-                  &            * ( ( sshn_e(ji,jj) + sshn_e(ji+1,jj) ) * 0.5  &
-                  &                - sshfow(jj) ) ) * uwmsk(jj,jk)
-               va_e(ji,jj) = vbtfow(jj) * uwmsk(jj,jk)
-            END DO
+         DO jj = 1, jpj
+            ua_e(ji,jj) = ( ubtfow(jj) * hur(ji,jj) - sqrt( grav * hur(ji,jj) )   &
+               &            * ( ( sshn_e(ji,jj) + sshn_e(ji+1,jj) ) * 0.5         &
+               &                - sshfow(jj) ) ) * uwmsk(jj,jk)
+            va_e(ji,jj) = vbtfow(jj) * hvr(ji,jj) * uwmsk(jj,jk)
          END DO
          DO jj = 1, jpj
@@ -155,10 +151,8 @@
 
       DO jj = njn0, njn1
-         DO jk = 1, jpkm1
-            DO ji = 1, jpi
-               va_e(ji,jj) = ( vbtfon(ji) + sqrt( grav * hv(ji,jj) )           &
-                  &            * ( ( sshn_e(ji,jj) + sshn_e(ji,jj+1) ) * 0.5   &
-                  &                - sshfon(ji) ) ) * vnmsk(ji,jk)
-            END DO
+         DO ji = 1, jpi
+            va_e(ji,jj) = ( vbtfon(ji) * hvr(ji,jj) + sqrt( grav * hvr(ji,jj) )   &
+               &            * ( ( sshn_e(ji,jj) + sshn_e(ji,jj+1) ) * 0.5         &
+               &                - sshfon(ji) ) ) * vnmsk(ji,jk)
          END DO
       END DO
@@ -170,5 +164,5 @@
             ssha_e(ji,jj) = ssha_e(ji,jj) * ( 1. - tnmsk(ji,1) ) &
                &            + sshfon(ji) * tnmsk(ji,1)
-            ua_e(ji,jj) = ubtfon(ji) * vnmsk(ji,jk)
+            ua_e(ji,jj) = ubtfon(ji) * hur(ji,jj) * vnmsk(ji,jk)
          END DO
       END DO
@@ -193,11 +187,9 @@
 
       DO jj = njs0, njs1
-         DO jk = 1, jpkm1
-            DO ji = 1, jpi
-               va_e(ji,jj) = ( vbtfos(ji) - sqrt( grav * hv(ji,jj) )            &
-                  &            * ( ( sshn_e(ji,jj) + sshn_e(ji,jj+1) ) * 0.5    &
-                  &                - sshfos(ji) ) ) * vsmsk(ji,jk)
-               ua_e(ji,jj) = ubtfos(ji) * vsmsk(ji,jk)
-            END DO
+         DO ji = 1, jpi
+            va_e(ji,jj) = ( vbtfos(ji) * hvr(ji,jj) - sqrt( grav * hvr(ji,jj) )   &
+               &            * ( ( sshn_e(ji,jj) + sshn_e(ji,jj+1) ) * 0.5         &
+               &                - sshfos(ji) ) ) * vsmsk(ji,jk)
+            ua_e(ji,jj) = ubtfos(ji) * hur(ji,jj) * vsmsk(ji,jk)
          END DO
          DO ji = 1, jpi
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcini.F90	(revision 2007)
@@ -70,5 +70,4 @@
 
       ! convert DOCTOR namelist name into the OLD names
-      nbobc    = nn_nbobc
       nobc_dta = nn_obcdta
       cffile   = cn_obcdta
@@ -101,5 +100,5 @@
       IF(lwp) WRITE(numout,*) 'obc_init : initialization of open boundaries'
       IF(lwp) WRITE(numout,*) '~~~~~~~~'
-      IF(lwp) WRITE(numout,*) '   Number of open boundaries    nn_nbobc = ', nn_nbobc
+      IF(lwp) WRITE(numout,*) '   Number of open boundaries    nbobc = ', nbobc
       IF(lwp) WRITE(numout,*)
 
@@ -306,4 +305,5 @@
       IF( lp_obc_east ) THEN
          !... (jpjed,jpjefm1),jpieob
+         bmask(nie0p1:nie1p1,nje0:nje1m1) = 0.e0
 
          ! ... initilization to zero
@@ -341,4 +341,5 @@
       IF( lp_obc_north ) THEN
          ! ... jpjnob,(jpind,jpisfm1)
+         bmask(nin0:nin1m1,njn0p1:njn1p1) = 0.e0
 
          ! ... initilization to zero
@@ -440,5 +441,5 @@
             END DO
          END IF
-  
+
          IF( lp_obc_north ) THEN ! ... North open boundary lateral surface
             DO jj = njn0, njn1
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/OBC/obcrst.F90	(revision 2007)
@@ -96,5 +96,5 @@
          ! -------------
 
-         CALL ctl_opn( inum, 'restart.obc.output', 'REPLACE', 'UNFORMATTED', 'DIRECT', nreclo, numout, lwp )
+         CALL ctl_opn( inum, 'restart.obc.output', 'UNKNOWN', 'UNFORMATTED', 'DIRECT', nreclo, numout, lwp )
  
          ! 1.2 Write header
@@ -322,5 +322,5 @@
       ! 0.1 Open files
       ! ---------------
-      CALL ctl_opn( inum, 'restart.obc', 'REPLACE', 'UNFORMATTED', 'DIRECT', nreclo, numout, lwp )
+      CALL ctl_opn( inum, 'restart.obc', 'UNKNOWN', 'UNFORMATTED', 'DIRECT', nreclo, numout, lwp )
 
       ! 1. Read
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 2007)
@@ -184,5 +184,5 @@
                         &                    nday   + 1                   - nmonth_len(nmonth) * COUNT((/llnxtmth/)), llstop )
 
-                     IF( sd(jf)%num == 0 .AND. .NOT. llstop ) THEN    ! next year file does not exist
+                     IF( sd(jf)%num <= 0 .AND. .NOT. llstop ) THEN    ! next year file does not exist
                         CALL ctl_warn('next year/month/day file: '//TRIM(sd(jf)%clname)//     &
                                 &     ' not present -> back to current year/month/day')
@@ -368,5 +368,5 @@
          
          ! if previous year/month/day file does not exist, we switch to the current year/month/day
-         IF( llprev .AND. sdjf%num == 0 ) THEN
+         IF( llprev .AND. sdjf%num <= 0 ) THEN
             CALL ctl_warn( 'previous year/month/day file: '//TRIM(sdjf%clname)//' not present -> back to current year/month/day')
             ! we force to read the first record of the current year/month/day instead of last record of previous year/month/day
@@ -399,5 +399,5 @@
       ENDIF
 
-      IF( sdjf%num == 0 )   CALL fld_clopn( sdjf, nyear, nmonth, nday )   ! make sure current year/month/day file is opened
+      IF( sdjf%num <= 0 )   CALL fld_clopn( sdjf, nyear, nmonth, nday )   ! make sure current year/month/day file is opened
 
       sdjf%nswap_sec = nsec_year + nsec1jan000 - 1   ! force read/update the after data in the following part of fld_read 
@@ -815,6 +815,5 @@
             WRITE(aname,'(a3,i2.2)') 'src',jn
             data_tmp(:,:) = 0
-            CALL iom_get ( inum, jpdom_unknown, aname, data_tmp(1:nlci,1:nlcj), &
-                           kstart=(/nimpp,njmpp/), kcount=(/nlci,nlcj/) )
+            CALL iom_get ( inum, jpdom_data, aname, data_tmp(:,:) )
             data_src(:,:) = INT(data_tmp(:,:))
             ref_wgts(nxt_wgt)%data_jpj(:,:,jn) = 1 + (data_src(:,:)-1) / ref_wgts(nxt_wgt)%ddims(1)
@@ -825,15 +824,14 @@
             aname = ' '
             WRITE(aname,'(a3,i2.2)') 'wgt',jn
-            ref_wgts(nxt_wgt)%data_wgt(1:nlci,1:nlcj,jn) = 0.0
-            CALL iom_get ( inum, jpdom_unknown, aname, ref_wgts(nxt_wgt)%data_wgt(1:nlci,1:nlcj,jn), &
-                           kstart=(/nimpp,njmpp/), kcount=(/nlci,nlcj/) )
+            ref_wgts(nxt_wgt)%data_wgt(:,:,jn) = 0.0
+            CALL iom_get ( inum, jpdom_data, aname, ref_wgts(nxt_wgt)%data_wgt(:,:,jn) )
          END DO
          CALL iom_close (inum)
  
          ! find min and max indices in grid
-         ref_wgts(nxt_wgt)%botleft(1) = MINVAL(ref_wgts(nxt_wgt)%data_jpi(1:nlci,1:nlcj,:))
-         ref_wgts(nxt_wgt)%botleft(2) = MINVAL(ref_wgts(nxt_wgt)%data_jpj(1:nlci,1:nlcj,:))
-         ref_wgts(nxt_wgt)%topright(1) = MAXVAL(ref_wgts(nxt_wgt)%data_jpi(1:nlci,1:nlcj,:))
-         ref_wgts(nxt_wgt)%topright(2) = MAXVAL(ref_wgts(nxt_wgt)%data_jpj(1:nlci,1:nlcj,:))
+         ref_wgts(nxt_wgt)%botleft(1) = MINVAL(ref_wgts(nxt_wgt)%data_jpi(:,:,:))
+         ref_wgts(nxt_wgt)%botleft(2) = MINVAL(ref_wgts(nxt_wgt)%data_jpj(:,:,:))
+         ref_wgts(nxt_wgt)%topright(1) = MAXVAL(ref_wgts(nxt_wgt)%data_jpi(:,:,:))
+         ref_wgts(nxt_wgt)%topright(2) = MAXVAL(ref_wgts(nxt_wgt)%data_jpj(:,:,:))
 
          ! and therefore dimensions of the input box
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90	(revision 2007)
@@ -311,8 +311,8 @@
 
       ! lateral boundary cond.: T-, U-, V-, F-pts, sgn
-      CALL lbc_lnk( gcost, 'T', 1. )   ;   CALL lbc_lnk( gsint, 'T', -1. )
-      CALL lbc_lnk( gcosu, 'U', 1. )   ;   CALL lbc_lnk( gsinu, 'U', -1. )
-      CALL lbc_lnk( gcosv, 'V', 1. )   ;   CALL lbc_lnk( gsinv, 'V', -1. )
-      CALL lbc_lnk( gcosf, 'F', 1. )   ;   CALL lbc_lnk( gsinf, 'F', -1. )
+      CALL lbc_lnk( gcost, 'T', -1. )   ;   CALL lbc_lnk( gsint, 'T', -1. )
+      CALL lbc_lnk( gcosu, 'U', -1. )   ;   CALL lbc_lnk( gsinu, 'U', -1. )
+      CALL lbc_lnk( gcosv, 'V', -1. )   ;   CALL lbc_lnk( gsinv, 'V', -1. )
+      CALL lbc_lnk( gcosf, 'F', -1. )   ;   CALL lbc_lnk( gsinf, 'F', -1. )
 
    END SUBROUTINE angle
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 2007)
@@ -23,4 +23,5 @@
    USE sbc_oce         ! Surface boundary condition: ocean fields
    USE sbc_ice         ! Surface boundary condition: ice fields
+   USE phycst          ! physical constants
 #if defined key_lim3
    USE par_ice         ! ice parameters
@@ -45,5 +46,4 @@
    USE lib_mpp         ! distribued memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE phycst, ONLY : xlsn, rhosn, xlic, rhoic
 #if defined key_cpl_carbon_cycle
    USE p4zflx, ONLY : oce_co2
@@ -274,5 +274,6 @@
       srcv(jpr_itz2)%clname = 'O_ITauz2'      ! 3rd   -      -         -     - 
       ! 
-      srcv(jpr_otx1:jpr_itz2)%nsgn = -1                           ! Vectors: change of sign at north fold
+      ! Vectors: change of sign at north fold ONLY if on the local grid
+      IF( TRIM( cn_rcv_tau(3) ) == 'local grid' )   srcv(jpr_otx1:jpr_itz2)%nsgn = -1.
       
       !                                                           ! Set grid and action
@@ -714,7 +715,6 @@
          IF( srcv(jpr_qnsoce)%laction )   qns(:,:) = frcv(:,:,jpr_qnsoce)
          IF( srcv(jpr_qnsmix)%laction )   qns(:,:) = frcv(:,:,jpr_qnsmix)        
-         !   energy for melting solid precipitation over free ocean
-         zcoef = xlsn / rhosn
-         qns(:,:) = qns(:,:) - frcv(:,:,jpr_snow) * zcoef
+         qns(:,:) = qns(:,:) - frcv(:,:,jpr_snow) * lfus              ! add the latent heat of solid precip. melting 
+
          !                                                       ! solar flux over the ocean          (qsr)
          IF( srcv(jpr_qsroce)%laction )   qsr(:,:) = frcv(:,:,jpr_qsroce) 
@@ -1117,9 +1117,6 @@
             &                                                   +          pist(:,:,1)   * zicefr(:,:,1) ) )
       END SELECT
-      !                                                           ! snow melting heat flux ....
-      !   energy for melting solid precipitation over ice-free ocean
-      zcoef = xlsn / rhosn
-      ztmp(:,:) = p_frld(:,:,1) * zsnow(:,:) * zcoef
-      pqns_tot(:,:) = pqns_tot(:,:) - ztmp(:,:)
+      ztmp(:,:) = p_frld(:,:,1) * zsnow(:,:) * lfus               ! add the latent heat of solid precip. melting
+      pqns_tot(:,:) = pqns_tot(:,:) - ztmp(:,:)                   ! over free ocean 
       IF( lk_diaar5 )   CALL iom_put( 'hflx_snow_cea', ztmp + zsnow(:,:) * zcptn(:,:) )   ! heat flux from snow (cell average)
 !!gm
@@ -1130,9 +1127,7 @@
 !!
 !! similar job should be done for snow and precipitation temperature
-      !                                                           ! Iceberg melting heat flux ....
-      !   energy for iceberg melting 
-      IF( srcv(jpr_cal)%laction ) THEN 
-         zcoef = xlic / rhoic
-         ztmp(:,:) = frcv(:,:,jpr_cal) * zcoef
+      !                                     
+      IF( srcv(jpr_cal)%laction ) THEN                            ! Iceberg melting 
+         ztmp(:,:) = frcv(:,:,jpr_cal) * lfus                     ! add the latent heat of iceberg melting 
          pqns_tot(:,:) = pqns_tot(:,:) - ztmp(:,:)
          IF( lk_diaar5 )   CALL iom_put( 'hflx_cal_cea', ztmp + frcv(:,:,jpr_cal) * zcptn(:,:) )   ! heat flux from calving
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 2007)
@@ -65,5 +65,5 @@
       INTEGER  ::   inum                  ! temporary logical unit
       INTEGER  ::   ikty, iyear           ! 
-      REAL(wp) ::   z_emp, z_emp_nsrf       ! temporary scalars
+      REAL(wp) ::   z_emp, z_emp_nsrf, zsum_emp, zsum_erp       ! temporary scalars
       REAL(wp) ::   zsurf_neg, zsurf_pos, zsurf_tospread
       REAL(wp), DIMENSION(jpi,jpj) ::   ztmsk_neg, ztmsk_pos, ztmsk_tospread
@@ -165,4 +165,6 @@
             !
             IF( lk_mpp )   CALL  mpp_sum( z_emp )
+            IF( lk_mpp )   CALL  mpp_sum( zsurf_neg )
+            IF( lk_mpp )   CALL  mpp_sum( zsurf_pos )
             
             IF( z_emp < 0.e0 ) THEN
@@ -177,7 +179,12 @@
 
             ! emp global mean over <0 or >0 erp area
-            z_emp_nsrf = SUM( e1e2_i(:,:) * z_emp ) / ( zsurf_tospread + rsmall )
+            zsum_emp = SUM( e1e2_i(:,:) * z_emp )
+            IF( lk_mpp )   CALL  mpp_sum( zsum_emp )
+            z_emp_nsrf =  zsum_emp / ( zsurf_tospread + rsmall )
             ! weight to respect erp field 2D structure 
-            z_wgt(:,:) = ztmsk_tospread(:,:) * erp(:,:) / ( SUM( ztmsk_tospread(:,:) * erp(:,:) * e1e2_i(:,:) ) + rsmall )
+            zsum_erp = SUM( ztmsk_tospread(:,:) * erp(:,:) * e1e2_i(:,:) )
+            IF( lk_mpp )   CALL  mpp_sum( zsum_erp )
+            z_wgt(:,:) = ztmsk_tospread(:,:) * erp(:,:) / ( zsum_erp + rsmall )
+
             ! final correction term to apply
             zerp_cor(:,:) = -1. * z_emp_nsrf * zsurf_tospread * z_wgt(:,:)
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 2007)
@@ -85,12 +85,10 @@
 !!gm here no overwrite, test all option via namelist change: require more incore memory
 !!gm  IF( lk_sbc_cpl       ) THEN   ;   ln_cpl      = .TRUE.   ;   ELSE   ;   ln_cpl      = .FALSE.   ;   ENDIF
-#if defined key_agrif
+
       IF ( Agrif_Root() ) THEN
-#endif
         IF( lk_lim2 )            nn_ice      = 2
         IF( lk_lim3 )            nn_ice      = 3
-#if defined key_agrif
-      ENDIF
-#endif
+      ENDIF
+      !
       IF( cp_cfg == 'gyre' ) THEN
           ln_ana      = .TRUE.   
